#include "stm32f10x.h"
#include "esp.h"
#include <stdio.h>
#include <stdarg.h>
#include "Delay.h"

uint8_t Serial_RxData;		//崮ڽյݱ
uint8_t Serial_RxFlag;		//崮ڽյı־λ

/**
  *     ڳʼ
  *     
  *   ֵ
  */
void Esp_Init(void)
{
	/*ʱ*/
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);	//USART1ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	//GPIOAʱ
	
	/*GPIOʼ*/
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);					//PA9ųʼΪ
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);					//PA10ųʼΪ
	
	/*USARTʼ*/
	USART_InitTypeDef USART_InitStructure;					//ṹ
	USART_InitStructure.USART_BaudRate =115200;				//
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//ӲƣҪ
	USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;	//ģʽģʽͽģʽѡ
	USART_InitStructure.USART_Parity = USART_Parity_No;		//żУ飬Ҫ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;	//ֹͣλѡ1λ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;		//ֳѡ8λ
	USART_Init(USART1, &USART_InitStructure);				//ṹUSART_InitUSART1
	
	/*ж*/
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);			//ڽݵж
	
	/*NVICжϷ*/
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);			//NVICΪ2
	
	/*NVIC*/
	NVIC_InitTypeDef NVIC_InitStructure;					//ṹ
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;		//ѡNVICUSART1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//ָNVIC·ʹ
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;		//ָNVIC·ռȼΪ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;		//ָNVIC·ӦȼΪ1
	NVIC_Init(&NVIC_InitStructure);							//ṹNVIC_InitNVIC
	
	/*USARTʹ*/
	USART_Cmd(USART1, ENABLE);								//ʹUSART1ڿʼ
}

/**
  *     ڷһֽ
  *     Byte Ҫ͵һֽ
  *   ֵ
  */
void Esp_SendByte(uint8_t Byte)
{
	USART_SendData(USART1, Byte);		//ֽдݼĴдUSARTԶʱ
	while (USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);	//ȴ
	/*´дݼĴԶɱ־λʴѭ־λ*/
}

/**
  *     ڷһַ
  *     String Ҫַ׵ַ
  *   ֵ
  */
void Esp_SendString(char *String)
{
	uint8_t i;
	for (i = 0; String[i] != '\0'; i ++)//ַ飨ַַ־λֹͣ
	{
		Esp_SendByte(String[i]);		//εSerial_SendByteÿֽ
	}
}


/**
  *     ʹprintfҪضĵײ㺯
  *     ԭʼʽɣ䶯
  *   ֵԭʼʽɣ䶯
  */
int fputc(int ch, FILE *f)
{
	Esp_SendByte(ch);			//printfĵײضԼķֽں
	return ch;
}

/**
  *     Լװprinf
  *     format ʽַ
  *     ... ɱĲб
  *   ֵ
  */
void Esp_Printf(char *format, ...)
{
	char String[100];				//ַ
	va_list arg;					//ɱб͵ıarg
	va_start(arg, format);			//formatʼղбarg
	vsprintf(String, format, arg);	//ʹvsprintfӡʽַͲбַ
	va_end(arg);					//arg
	Esp_SendString(String);		//ڷַ飨ַ
}

/**
  *     ȡڽձ־λ
  *     
  *   ֵڽձ־λΧ0~1յݺ󣬱־λ1ȡ־λԶ
  */
uint8_t Esp_GetRxFlag(void)
{
	if (Serial_RxFlag == 1)			//־λΪ1
	{
		Serial_RxFlag = 0;
		return 1;					//򷵻1Զ־λ
	}
	return 0;						//־λΪ0򷵻0
}

/**
  *     ȡڽյ
  *     
  *   ֵյݣΧ0~255
  */
uint8_t Esp_GetRxData(void)
{
	return Serial_RxData;			//ؽյݱ
}

/**
  *     USART1жϺ
  *     
  *   ֵ
  * ע˺ΪжϺãжϴԶִ
  *           ΪԤָƣԴļ
  *           ȷȷκβ죬жϺܽ
  */
void USART1_IRQHandler(void)
{
	if (USART_GetITStatus(USART1, USART_IT_RXNE) == SET)		//жǷUSART1Ľ¼ж
	{
		Serial_RxData = USART_ReceiveData(USART1);				//ȡݼĴڽյݱ
		Serial_RxFlag = 1;										//ýձ־λΪ1
		USART_ClearITPendingBit(USART1, USART_IT_RXNE);			//USART1RXNE־λ
																//ȡݼĴԶ˱־λ
																//ѾȡݼĴҲԲִд˴
	}
}

#define Wifi "ESP8266"
#define WifiPassword "1234567890"
#define port	"2024"

void  Esp_SetInstall(void){
	Esp_Printf("AT+RST\r\n");
	Delay_ms(500);
	Esp_Printf("AT+CWSAP=\"%s\",\"%s\",6,4\r\n",Wifi,WifiPassword);
	Delay_ms(500);
	Esp_Printf("AT+RST\r\n");
	Delay_ms(500);
	Esp_Printf("AT+CWMODE=2\r\n");
	Delay_ms(500);
	Esp_Printf("AT+CIPMUX=1\r\n");
	Delay_ms(500);
	Esp_Printf("AT+CIPSERVER=1,%s\r\n",port);
	Delay_ms(500);
	Esp_Printf("AT+CIPSEND=0,5\r\n");
	Delay_ms(500);
	Esp_Printf("OK\r\n");
	Delay_ms(500);
}